Unit KocsiVerem_Unit_2;
(*
   KocsiVerem_Unit <= Verem_Unit_2
   Kdols: IBM852
*)

Interface
  {
	       TKocsi elemekbl ll, folytonos-brzols vermek kezelse:
  }
  Const MaxMelyseg=100;
  Type	TKocsi=Record
                 cel:Word;
                 aru:String[5]
               End;
        TElem =TKocsi;
        TVerem=Record
                 ve:Array [1..MaxMelyseg] of TElem;
                 teteje:0..MaxMelyseg;
                 hiba:Boolean;
               End;

  Procedure Ures {legyen}(Var v:TVerem);
  Function  UresE {?}(v:TVerem):Boolean;
  Function VeremMelyseg(Const v:TVerem):Integer;
  Procedure Verembe(Var v:TVerem; Const e:TElem);
  Function Verembol(Var v:TVerem):TElem;
  Function Teto(Var v:TVerem):TElem;
  Function TeleE {?}(Const v:TVerem):Boolean;
  Function HibasE {?}(Var v:TVerem):Boolean;
  Procedure VeremKiir(Const cim:String; Const v:TVerem);

Implementation

  Uses
    Crt;
    {$i ..\..\Rutinok\AltRutinok.inc}

  Procedure Ures {legyen}(Var v:TVerem);
  Begin
    v.teteje:=0; v.hiba:=False;
  End;

  Function UresE {?}(v:TVerem):Boolean;
  Begin
    UresE:=(v.teteje=0);
  End;

  Function VeremMelyseg(Const v:TVerem):Integer;
  Begin
    VeremMelyseg:=v.teteje;
  End;
  
  Procedure Verembe(Var v:TVerem; Const e:TElem);
  Begin
    If not TeleE(v) then
    Begin
      Inc(v.teteje); v.ve[v.teteje]:=e;
    End
      else
    Begin
      v.hiba:=True;
    End
  End;

  Function Verembol(Var v:TVerem):TElem;
  Begin
    If not UresE(v) then
    Begin
      Verembol:=v.ve[v.teteje]; Dec(v.teteje);
    End
      else
    Begin
      v.hiba:=True;
    End
  End;

  Function Teto(Var v:TVerem):TElem;
  Begin
    If not UresE(v) then
    Begin
      Teto:=v.ve[v.teteje];
    End
      else
    Begin
      v.hiba:=True;
    End;
  End;

  Function TeleE {?}(Const v:TVerem):Boolean;
  Begin
    TEleE:=v.teteje=MaxMelyseg
  End;

  Function HibasE {?}(Var v:TVerem):Boolean;
  Begin
    HibasE:=v.hiba; v.hiba:=False;
  End;

  Const
    vonalasSor:String='-------------------------------------------------------------';

  Procedure VeremKiir(Const cim:String; Const v:TVerem);
    Const
      IgazHamis:Array [Boolean] of String=('Hamis','Igaz');
    Var
      i:Integer;
  Begin
    Writeln(vonalasSor);
    Writeln(cim);
    Writeln('Elemszm:',v.teteje);
    Writeln('Az elemek:');
    For i:=1 to v.teteje do
    Begin
      Writeln(i:3,'.: ',v.ve[i].cel,',"',v.ve[i].aru,'"');
    End;
    Writeln('Hibs-e:',IgazHamis[v.hiba]);
    Writeln(vonalasSor);
    BillreVar();
  End;

Begin
End.
