Program KocsizoProgram;
(*
   Szerz: Szlvi Pter
   Mail:   szlavip@elte.hu
   
   Feladat: Kzismereti informatika trgy 2. flv, 1. zh-ra felkszt.
            L. Konzultaciora.pdf
*)
  Uses
    Crt,KocsiVerem_Unit_2;
    {$i ..\..\Rutinok\AltRutinok.inc}
  Var
    beVer,
    kiVer:TVerem{TKocsi};
    irsz:Word;

  Procedure Beolvasas;
    Var
      hiba:Boolean;
      n,i:Integer;
      e:TElem;
  Begin
	Ures(beVer);
	//beolvass: elemszm
    Repeat
      Write('Kocsik szma:'); {$i-}Readln(n);{$i+}
      hiba:=(IOResult<>0) or (n<0) or (n>MaxMelyseg);
    Until not hiba;
	//beolvass: elemek
    For i:=1 to n do
    Begin
      Repeat
        Write(i:3,'. cl: '); {$i-}Readln(e.cel);{$i+}
        hiba:=(IOResult<>0) or (e.cel<1000) or (e.cel>9999);
      Until not hiba;
      Repeat
        Write(i:3,'. ru: '); Readln(e.aru);
        hiba:=(Length(e.aru)<>5);
      Until not hiba;
      Verembe(beVer,e);
    End;
    VeremKiir('A szerelvny kezdetben:',beVer);
    //beolvass: kiemelendk irnytszma
    Repeat
      Write('A kiemelend kocsik irnytszma:'); {$i-}Readln(irsz);{$i+}
      hiba:=(IOResult<>0) or (irsz<1000) or (irsz>9999);
      If hiba then
      Begin
        Writeln('Rossz az irnytszm. Krem jra!');
      End;
    Until not hiba;
  End;
  
  Procedure Lenyeg;
    Var
      sVer:TVerem{TKocsi};
      e:TKocsi;
      i:Integer;
  Begin
    UjLap('Rajta!!!',1);
    Ures(sVer);
    Writeln('  1. lps: a kicsatoland mgttiek elklntse egy segd verembe');
    While not UresE(beVer) and (Teto(beVer).cel<>irsz) do
    Begin
      e:=Verembol(beVer); Verembe(sVer,e);
      Writeln('Mvelet: bemeneti verem->segd verem');
      VeremKiir('Bemeneti verem:',beVer);
      VeremKiir('Segd verem:',sVer);
    End;
    Writeln('  2. lps: a kicsatolandk a kimeneti verembe');
    Ures(kiVer);
    VeremKiir('Kimeneti verem:',kiVer);
    While not UresE(beVer) and (Teto(beVer).cel=irsz) do
    Begin
      e:=Verembol(beVer); Verembe(kiVer,e);
      Writeln('Mvelet: bemeneti verem->kimeneti verem');
      VeremKiir('Bemeneti verem:',beVer);
      VeremKiir('Kimeneti verem:',kiVer);
    End;
    Writeln('  3. lps: a segd verembeliek az eredeti verembe vissza');
    For i:=1 to VeremMelyseg(sVer) do
    Begin
      e:=Verembol(sVer); Verembe(beVer,e);
      Writeln('Mvelet: segd verem->bemeneti verem');
      VeremKiir('Segd verem:',sVer);
      VeremKiir('Bemeneti verem:',beVer);
    End;
  End;

  Procedure Kiiras;
  Begin
    VeremKiir('A szerelvny a vgn:',beVer);
    VeremKiir('A kicsatolt kocsik szerelvnye:',kiVer);
  End;

Begin
  UjLap('Vakvnyos kocsizs program',1);
  Beolvasas;
  Lenyeg;
  Kiiras;
End.
